---------------------------------------------------------
-- X^7: }X^̃\[XR[h
---------------------------------------------------------
library IEEE;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_arith.all;

-- W[̊Og̒`
entity master is
  port (
    pClk   : in std_logic;              -- ̓NbN
    pReset : in std_logic               -- ZbgM
    );
end master;

architecture RTL of master is

  type StateType is (IDLE, REQ, REQ_CLEAR, BUSY_WAIT, MASTER_EXEC);
  signal state : StateType := IDLE;

  component slave
    port (
      pClk   : in std_logic;              -- ̓NbN
      pReq   : in std_logic;              -- NGXg󂯂
      pBusy  : out std_logic;             -- NGXg󂯂
      pReset : in std_logic               -- ZbgM
    );
  end component;

  signal cReq: std_logic := '0';
  signal cBusy: std_logic;
  
begin  -- RTL

  U0: slave port map (
    pClk => pClk,
    pReq => cReq,
    pBusy => cBusy,
    pReset => pReset);

  process (pClk, pReset)
  begin
    if pReset = '1' then
      state   <= IDLE;
      cReq <= '0';
    elsif pClk'event and pClk = '1' then
      case state is
        when IDLE =>
          cReq <= '0';
         state <= REQ;
        when REQ =>
          -- X[udĂȂƂmFăNGXg𔭍s
          if cBusy = '0' then
            cReq <= '1';
            state <= REQ_CLEAR;
          end if;
        when REQ_CLEAR =>
          -- X[uJn烊NGXg
          if cBusy = '1' then
            cReq <= '0';
            state <= BUSY_WAIT;
          end if;
        when BUSY_WAIT =>
          -- X[u܂ő҂D
          if cBusy = '0' then
            state <= MASTER_EXEC;
          end if;            
        when MASTER_EXEC =>
          -- }X^̎dɖ߂(ł͉ĂȂ)
          state <= IDLE;
        when others =>
          null;
      end case;
    end if;
  end process;

end RTL;
