---------------------------------------------------------
-- Xg6: X[ũ\[XR[h
---------------------------------------------------------
library IEEE;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_arith.all;

-- W[̊Og̒`
entity slave is
  port (
    pClk   : in std_logic;              -- ̓NbN
    pReq   : in std_logic;              -- NGXg󂯂
    pBusy  : out std_logic;             -- NGXg󂯂
    pReset : in std_logic               -- ZbgM
    );

end slave;

architecture RTL of slave is

  type StateType is (IDLE, EXEC);
  signal state : StateType := IDLE;
  
  signal counter : std_logic_vector(3 downto 0);

begin  -- RTL

  process (pClk, pReset)
  begin
    if pReset = '1' then
      state   <= IDLE;
      counter <= (others => '0');
      pBusy <= '0';
    elsif pClk'event and pClk = '1' then
      case state is
        when IDLE =>
          counter <= (others => '0');
          if pReq = '1' then
            pBusy <= '1';
            state <= EXEC;
          else
            pBusy <= '0';
          end if;
        when EXEC =>
          counter <= counter + 1;
          if counter = "1111" then
            state <= IDLE;
          end if;
        when others =>
          null;
      end case;
    end if;
  end process;

end RTL;
